> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# List API usage detail records

GET https://rest.test.zuora.com/system-health/api-requests/details

Returns records of API usage that are generated by your Zuora tenant within a specified time range.


You can filter the records by one or multiple of the following fields:
  - API path name
  - HTTP method
  - Response code 
  - Request ID
  - Track ID


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/system-health/api-health/get-system-health-api-performance-records

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Query parameters

- `page` (integer, optional, default: 1) — The index number of the page that you want to retrieve. This parameter is dependent on `pageSize`. You must set `pageSize` before specifying `page`. For example, if you set `pageSize` to `20` and `page` to `2`, the 21st to 40th records are returned in the response.
- `pageSize` (integer, optional, default: 20) — The number of records returned per page in the response.
- `path` (string, optional) — Filters the volume summary by API path name. You can refer to the API listed in the [API System Health Dashboard](https://knowledgecenter.zuora.com/Zuora_Central_Platform/Zuora_System_Health/B_APIs_dashboard) for the path name.
- `httpMethod` (string, optional) — Filters the volume summary by http method.
- `responseCode` (string, optional) — Filters the volume summary by response code.
- `requestId` (string, optional) — Filters the volume summary by request ID.
- `trackId` (string, optional) — Filters the volume summary by track ID.
- `sort` (string, optional) — This parameter restricts the order of the data returned in the response. You can use this parameter to supply a dimension you want to sort on. A sortable field uses the following form: *operator* *field_name*. If you do not specify any sortable field, the response data is sorted by the `timerange` field in descending order. *operator* is used to mark the order of sequencing. The operator is optional. If you only specify the sortable field without any operator, the response data is sorted in descending order by this field. - The `-` operator indicates an ascending order. - The `+` operator indicates a descending order. *field_name* indicates the name of a sortable field. The supported sortable fields of this operation are as below: - `timerange` - `latency` - `http_method` - `http_status` - `api`
- `startTime` (datetime, required) — Start time of the volume summary. Format: `yyyy-MM-dd'T'HH:mmZ`.
- `endTime` (datetime, required) — End time of the volume summary. Format: `yyyy-MM-dd'T'HH:mmZ`

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).

## Response

### 200

OK

- `data` (list of ApiPerformanceDetail, optional) — List of API Records in detail.
- `nextPage` (string, optional) — URL to the next page of results for pagination.

## Errors

### 400 Bad Request Error

Bad Request

- `error` (string, optional) — Error status text.
- `message` (string, optional) — The associated reason.
- `path` (string, optional) — The system health api path having error.
- `status` (integer, optional) — Error status code.
- `timestamp` (datetime, optional) — The time when error happens.

## Types

### ApiPerformanceDetail

A list of failure records including additional details about the request and response.

- `tracing_identifier` (string, optional, nullable) — A unique identifier for tracing the request.
- `latency` (integer, optional) — The time taken to process the request in milliseconds.
- `ip` (string, optional, nullable) — The IP address from which the request originated.
- `response_body` (string, optional, nullable) — The body of the response returned by the API.
- `request_body` (string, optional, nullable) — The body of the request sent to the API.
- `user_id` (string, optional) — The ID of the user making the request.
- `track_id` (string, optional, nullable) — A tracking identifier for the request.
- `request_path` (string, optional) — The complete path of the API request triggered by the user.
- `http_status` (string, optional) — The HTTP status code returned by the API.
- `zuora_response_code` (string, optional) — The response code returned by Zuora.
- `api` (string, optional) — The path of the API request.
- `request_id` (string, optional) — A unique identifier for the API request.
- `user_agent` (string, optional) — The user agent string of the client making the request.
- `timestamp` (datetime, optional) — The timestamp when the request was made.
- `status` (enum, optional) — The status of the request.
  - Allowed values: `Error`, `Success`
- `http_method` (string, optional) — Type of request method performed for the API endpoint.

## Examples

**Response**

```json
{
  "data": [
    {
      "tracing_identifier": null,
      "latency": 1913,
      "ip": "52.0.173.190",
      "response_body": "{\"code\":\"REQUEST_EXCEEDED_LIMIT\",\"message\":\"Your total number of concurrent requests have exceeded the limit allowed by the system. Please resubmit your request later.\"}",
      "request_body": null,
      "user_id": "4028e4883824800301382f1817921f3d",
      "track_id": null,
      "request_path": "/apps/services/a/68.0",
      "http_status": "429",
      "zuora_response_code": "TOO_MANY_REQUESTS",
      "api": "soap",
      "request_id": "628fc2f4-8ab4-4e2d-bfd4-eb15fd4d2f52",
      "user_agent": "Axis2",
      "timestamp": "2025-01-04T13:10:53Z",
      "status": "Error",
      "http_method": "POST"
    },
    {
      "tracing_identifier": null,
      "latency": 50218,
      "ip": "52.52.63.58",
      "response_body": null,
      "request_body": null,
      "user_id": "4028e4883824800301382f1817922f3d",
      "track_id": null,
      "request_path": "soap:login",
      "http_status": "200",
      "zuora_response_code": "Success",
      "api": "soap:login",
      "request_id": "34f4ce61-67be-42f5-bee5-c2665a905dfa",
      "user_agent": "Axis2",
      "timestamp": "2025-01-01T18:03:49Z",
      "status": "Success",
      "http_method": "POST"
    }
  ],
  "nextPage": "/system-health/api-requests/details?startTime=2024-08-01T09:07+0800&endTime=2024-08-05T09:07+0800&limit=10&page=2"
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/system-health/api-requests/details"

querystring = {"endTime":"2022-09-29T09:07+0800","httpMethod":"POST","path":"/v1/accounts/{account-key}","responseCode":"INVALID_TYPE","sort":"sort=+latency","startTime":"2022-09-22T09:07+0800"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/system-health/api-requests/details?endTime=2022-09-29T09%3A07%2B0800&httpMethod=POST&path=%2Fv1%2Faccounts%2F%7Baccount-key%7D&responseCode=INVALID_TYPE&sort=sort%3D%2Blatency&startTime=2022-09-22T09%3A07%2B0800';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/system-health/api-requests/details?endTime=2022-09-29T09%3A07%2B0800&httpMethod=POST&path=%2Fv1%2Faccounts%2F%7Baccount-key%7D&responseCode=INVALID_TYPE&sort=sort%3D%2Blatency&startTime=2022-09-22T09%3A07%2B0800"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/system-health/api-requests/details?endTime=2022-09-29T09%3A07%2B0800&httpMethod=POST&path=%2Fv1%2Faccounts%2F%7Baccount-key%7D&responseCode=INVALID_TYPE&sort=sort%3D%2Blatency&startTime=2022-09-22T09%3A07%2B0800")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/system-health/api-requests/details?endTime=2022-09-29T09%3A07%2B0800&httpMethod=POST&path=%2Fv1%2Faccounts%2F%7Baccount-key%7D&responseCode=INVALID_TYPE&sort=sort%3D%2Blatency&startTime=2022-09-22T09%3A07%2B0800")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/system-health/api-requests/details?endTime=2022-09-29T09%3A07%2B0800&httpMethod=POST&path=%2Fv1%2Faccounts%2F%7Baccount-key%7D&responseCode=INVALID_TYPE&sort=sort%3D%2Blatency&startTime=2022-09-22T09%3A07%2B0800', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/system-health/api-requests/details?endTime=2022-09-29T09%3A07%2B0800&httpMethod=POST&path=%2Fv1%2Faccounts%2F%7Baccount-key%7D&responseCode=INVALID_TYPE&sort=sort%3D%2Blatency&startTime=2022-09-22T09%3A07%2B0800");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/system-health/api-requests/details?endTime=2022-09-29T09%3A07%2B0800&httpMethod=POST&path=%2Fv1%2Faccounts%2F%7Baccount-key%7D&responseCode=INVALID_TYPE&sort=sort%3D%2Blatency&startTime=2022-09-22T09%3A07%2B0800")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```